/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.resource;

import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.Icon;
import javax.swing.ImageIcon;

public class ResourceManager1 extends ResourceManager {
	protected ResourceBundle rb;
	protected String baseName,iconPath;
	
	public ResourceManager1(String subDir, Locale locale) {
		if (subDir==null) {
			baseName="locale/";
			iconPath="icons/";
		} else {
			baseName=subDir+"locale/";
			iconPath=subDir+"icons/";
		}
		setLocale(locale);
	}
	
	
	@Override
	public String getLocalizedString(String key) {
		return rb.getString(key);
	}
	
	@Override
	public void setLocale(Locale l) {
		rb=ResourceBundle.getBundle(baseName, l) ;
	}

	@Override
	public Icon getIcon(String string) {
		return new ImageIcon(ClassLoader.getSystemClassLoader().getResource(iconPath+getLocalizedString(string)));
	}
}
